function [newstate] = applyR(action, state)

   % Applies an action in a state, yielding a new state 
   % in the random (R) environment

   statevec = statedecode(state);
   actvec = actdecode(action);
   centerstate = [statevec(1:2)+actvec statevec(3:4)];
   newstates = repmat(centerstate,5,1);
   newstates = [ newstates(:,1:2) newstates(:,3:4) + [0 -1;-1 0;0 0;1 0;0 1] ];

   newstatevec = newstates(ceil(rand*5),:);

   newstatevec = max(0, newstatevec);
   newstatevec = min(3, newstatevec);
   newstate = statencode(newstatevec);

   % This selection model matches the conditional probabilities in "Probs" 
   % by construction.  Unfortunately, this relationship is not explicit 
   % in this code.  You'll just have to trust me.  Sorry about that.

