function A = enum(n,b)

   %  Generates matrix of all possible row vectors of length n
   %  with components chosen from {0,1,...,b}
   %
   %  E.g. enum(3,2) returns
   %
   %  ans =
   %   
   %       0     0     0
   %       1     0     0
   %       0     1     0
   %       1     1     0
   %       0     0     1
   %       1     0     1
   %       0     1     1
   %       1     1     1

   for i = 1:n
      expi = b.^(i-1)
      A(:,i) = repmat(reshape(repmat(0:b-1,expi,1),b*expi,1),b.^(n-i),1);
   end

